#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "algrafo.h"



/* Funes Lista - Ligada */
node NovaLista() {
  return NULL;
}

node AddLista(node lista, int item) {
  node a = malloc(sizeof*a);
  a->num = item;
  a->next = lista;
  return a;
}

int BuscaLista(node lista, int item) {
  while(lista) {
    if(item==lista->num)
      return 1;
    lista = lista->next;
  }
  return 0;	
}

node RemoveLista(node lista, int item) {
  node a;
  if(lista==NULL)
    return NULL;
  if(item==lista->num) {
    a = lista->next;
    free(lista);
    return RemoveLista(a,item);
  }
  lista->next = RemoveLista(lista->next, item);
  return lista;
}

void DestroiLista(node lista) {
  node a;
  while(lista) {
    a = lista->next;
    free(lista);
    lista=a;
  }
}

void ImprimeLista(node lista) {
  while(lista) {
    printf("[%d]",lista->num);
    lista = lista->next;
  }
  printf("\n");
}

/* fim das funcoes de Lista Ligada */

node* Listagem(int a);
int* Graus(int a, int valor);
Graph GRAPHinit(int a) {
  Graph b = malloc(sizeof*b);
  b->V = a;
  b->E = 0;
  b->listas = Listagem(a);
  return b;
}

void GRAPHinsertE(Graph a, Edge b) {

  if(BuscaLista(a->listas[b.w], b.v) || b.w == b.v)
    return;
  (a->E)++;	
  a->listas[b.v] = AddLista(a->listas[b.v], b.w);
  a->listas[b.w] = AddLista(a->listas[b.w], b.v);		
}

void GRAPHremoveE(Graph a, Edge b) {
  if(BuscaLista(a->listas[b.v], b.w)) {
    a->listas[b.v] = RemoveLista(a->listas[b.v], b.w);
    a->listas[b.w] = RemoveLista(a->listas[b.w], b.v);
    (a->E)--;
  }
}

void GRAPHdestroy(Graph a) {
  int i;
  for(i=0;i<a->V;i++) {
    DestroiLista(a->listas[i]);
    
  }
  free(a->listas);
  free(a);
}

void GRAPHshow(Graph g) {
  int b;
  printf("[%d Arestas, %d Vertices]\n",g->E, g->V);
  for(b=0;b<g->V;b++) {
    printf("%d: ",b);
    ImprimeLista(g->listas[b]);

  }
}

Graph GRAPHrand(int V, int E) {
  Edge arr;
  Graph a = GRAPHinit(V);
  while(a->E<E) {
    arr.w = rand()%V;
    arr.v = rand()%V;
    fflush(NULL);
    GRAPHinsertE(a, arr);
  }
  return a;

}

Graph GRAPHscan(int V, int E) {
  Edge arr;
  int i;
  Graph a = GRAPHinit(V);
  for(i=0;i<E;i++) {
    scanf("%d %d", &arr.v, &arr.w);
    GRAPHinsertE(a, arr);
  }
  return a;
}


node* Listagem(int a) {
  node* n;
  int i;
  n = malloc(a*sizeof(node*));
  for(i=0;i<a;i++)
    n[i]=NULL;
  return n;	
}

int BProfRec(Graph g, int* buffer, int pre, int vertice) {
  node a;
  for(a=g->listas[vertice];a!=NULL;a=a->next) {
    if(buffer[a->num]==0) {
      pre++;
      buffer[a->num]=1;
      pre = BProfRec(g, buffer,pre,a->num);
    }
  }
  return pre;
}
int GRAPHconexo(Graph g) {
  int i;
  int *buffer;
  if(!g)
    return 1;
  buffer = malloc(g->V*(sizeof*buffer));
  buffer[0] =1;
  for(i=1;i<g->V;i++)
    buffer[i]=0;
  
  i = BProfRec(g,buffer,1,0);
  free(buffer);		
  return i==g->V;
	
}
